import { Directive, ElementRef, EventEmitter, Input, NgModule, Output } from '@angular/core';

var __decorate$1 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
let ClipboardDirective = class ClipboardDirective {
    /**
     * @param {?} elmRef
     */
    constructor(elmRef) {
        this.elmRef = elmRef;
        this.cbOnSuccess = new EventEmitter();
        this.cbOnError = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        let /** @type {?} */ option;
        option = !!this.targetElm ? { target: () => (this.targetElm) } : { text: () => this.cbContent };
        this.clipboard = new Clipboard(this.elmRef.nativeElement, option);
        this.clipboard.on('success', () => this.cbOnSuccess.emit(true));
        this.clipboard.on('error', () => this.cbOnError.emit(true));
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.clipboard) {
            this.clipboard.destroy();
        }
    }
};
__decorate$1([
    Input('ngxClipboard'),
    __metadata("design:type", ElementRef)
], ClipboardDirective.prototype, "targetElm", void 0);
__decorate$1([
    Input(),
    __metadata("design:type", String)
], ClipboardDirective.prototype, "cbContent", void 0);
__decorate$1([
    Output(),
    __metadata("design:type", EventEmitter)
], ClipboardDirective.prototype, "cbOnSuccess", void 0);
__decorate$1([
    Output(),
    __metadata("design:type", EventEmitter)
], ClipboardDirective.prototype, "cbOnError", void 0);
ClipboardDirective = __decorate$1([
    Directive({
        selector: '[ngxClipboard]'
    }),
    __metadata("design:paramtypes", [ElementRef])
], ClipboardDirective);

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
let ClipboardModule = class ClipboardModule {
};
ClipboardModule = __decorate([
    NgModule({
        declarations: [ClipboardDirective],
        exports: [ClipboardDirective]
    })
], ClipboardModule);

export { ClipboardDirective, ClipboardModule };
//# sourceMappingURL=ngx-clipboard.js.map
